// Italk Protocol 1.0 and biff-port support modifications.
// Copyright (C) 1998, SAKAMOTO Takahiro <takas@is.s.u-tokyo.ac.jp>
// Copyright (C) 1998, KANEKO Wataru <wataruk@is.s.u-tokyo.ac.jp>

/*
 * WItalk2 - italk client for Win32
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// WItalk2 - WItalk2 ƖOt_ 3 łȂƂ͊m肵Ă :)

#include	<winsock2.h>
#include	<crtdbg.h>
#include	<stdlib.h>
#include	<time.h>
#include	<crtdbg.h>
#include	<shlobj.h>
#include	<shlguid.h>
#include	<objbase.h>

#include	"Dialog.h"
#include	"WItalk2.h"
#include	"rWItalk2.h"
#include	"lgFiles.h"
#include	"DialogURL.h"
#include	"DialogParanoia1.h"
#include	"DialogKillName.h"
#include	"WinDLL.h"
#include	"AboutDialog.h"
#include	"BackLogWindow.h"
#include	"ProfileManager.h"
#include	"AttachFile.h"
#include	"TimerQueue.h"

#include	<openssl/crypto.h>
#include	<openssl/x509.h>
#include	<openssl/ssl.h>
#include	<openssl/err.h>

extern int		telegramWindowClose;
extern bool		sent_handle;				// Waffle 0.1.11

#define WC_WITALK2 "WItalk2"
#define WM_APP_CONNECT_TO (WM_APP + 300)

extern	int window_transparency;
extern	bool does_window_transparent, does_users_window_transparent, does_telegram_window_transparent;
bool	does_window_transparent = false;
bool	does_users_window_transparent = false;
bool	does_telegram_window_transparent = false;
int		window_transparency = 255;
extern	HWND	firstWindow;
HWND	firstWindow;

// {56FDF344-FD6D-11d0-958A-006097C9A090}
DEFINE_GUID(CLSID_TaskbarList, 0x56fdf344, 0xfd6d, 0x11d0, 0x95, 0x8a, 0x0, 0x60, 0x97, 0xc9, 0xa0, 0x90);
// {56FDF342-FD6D-11d0-958A-006097C9A090}
DEFINE_GUID(IID_ITaskbarList, 0x56fdf342, 0xfd6d, 0x11d0, 0x95, 0x8a, 0x0, 0x60, 0x97, 0xc9, 0xa0, 0x90);

// pI


extern	char	iniFileName[BUFSIZE];

HINSTANCE	hinstance;

///////////////////////////////////////////////////////////////////////////////
// Property Sheet ֘A

#define SetPropertySheetPage(n, name, pd)				\
psp[n].dwSize	   = sizeof(PROPSHEETPAGE);				\
psp[n].dwFlags	   = 0; 						\
psp[n].hInstance   = lgWindows::hInst();				\
psp[n].pszTemplate = MAKEINTRESOURCE(rDialog##name);			\
psp[n].pszIcon	   = 0; 						\
psp[n].pfnDlgProc  = (DLGPROC)Dialog##name##DlgProc;			\
psp[n].pszTitle    = NULL;						\
psp[n].lParam	   = (LPARAM)(pd);					\
psp[n].pfnCallback = NULL;

#define SetPropertySheetHeader(icon, title)				\
psh.dwSize	= sizeof(PROPSHEETHEADER);				\
psh.dwFlags	= PSH_USEICONID | PSH_PROPSHEETPAGE | PSH_MODELESS;	\
psh.hwndParent	= Hwnd();						\
psh.hInstance	= lgWindows::hInst();					\
psh.pszIcon	= MAKEINTRESOURCE(icon);				\
psh.pszCaption	= LoadString(title);					\
psh.nPages	= ArrayNum(psp);					\
psh.nStartPage	= page; 						\
psh.ppsp	= (LPCPROPSHEETPAGE) &psp;				\
psh.pfnCallback = NULL;

LPSTR	commandLine;					// R}hCIvV

///////////////////////////////////////////////////////////////////////////////
// WItalk2

void WItalk2::show_error_message(const char *buf)
{
	if (statusbar) {
		statusbar->SetText(buf);
		statusbar->SetColor(RGB(255, 255, 255), RGB(255, 0, 0), TRUE);
	}
}

void WItalk2::reset_focus(void)
{
	PostMessage(Hwnd(), WM_SETFOCUS, (WPARAM)GetFocus(), 0);
}

// g`܂
void WItalk2::paint(HDC hdc)
{
	RECT rc;
	GetChildWindowRect(hwnd_splitbar, &rc);
	//lgGUIParts::Draw3DFrame(hdc, rc, lgGUIParts::FrameDown2); comment outed by sept

	RECT _rc = rc;
	_rc.top    = rc.top	- 2 - TOOLBAR_MAGIC_NUMBER;
	_rc.left   = rc.left	- 2;
	_rc.bottom = rc.top	- 2;
	_rc.right  = rc.right + 2;

	if (!IsWindowVisible(hwnd_url)) {
		GetChildWindowRect(toolbar->Hwnd(), &rc);
		_rc.top = rc.bottom;
	}

	HBRUSH hbrush = CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	FillRect(hdc, &_rc, hbrush);
	DeleteObject(hbrush);
}

// Waffle 0.2.1b: ^XNgCACRݒ
void WItalk2::initializeTrayiconinfo()
{
	if (trayiconinfo == 0) trayiconinfo = new NOTIFYICONDATA;
	trayiconinfo->cbSize = sizeof(NOTIFYICONDATA);
	trayiconinfo->hWnd = Hwnd();
	trayiconinfo->uID = 0x4624*3 + (unsigned int)trayiconinfo->hWnd;
	trayiconinfo->uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	trayiconinfo->uCallbackMessage = rCommandTasktrayNotify;
	trayiconinfo->hIcon = LoadIcon(lgWindows::hInst(), MAKEINTRESOURCE(rIconWItalk2));
	strcpy(trayiconinfo->szTip, "WItalk2");
}

// Waffle 0.2.1b: ^XNgCAbvf[g
void WItalk2::updateIconOnTasktray()
{
	if (!trayiconinfo) initializeTrayiconinfo();
	/* c[`bvbZ[W̐ݒ */
	if (isConnectionActive){
		sprintf(trayiconinfo->szTip, "%s:%u", szItalkHost, uItalkPort);
	} else {
		strcpy(trayiconinfo->szTip, "WItalk2 (not connected)");
	}
	Shell_NotifyIcon(NIM_MODIFY, trayiconinfo);
}

// Waffle 0.2.1b: ^XNgCɃACRo^
void WItalk2::registerIconOnTasktray()
{
	if (!trayiconinfo) initializeTrayiconinfo();
	Shell_NotifyIcon(NIM_ADD, trayiconinfo);
}

// Waffle 0.2.1b: ^XNgCACR폜
void WItalk2::unregisterIconFromTasktray()
{
	if (!trayiconinfo) initializeTrayiconinfo();
	Shell_NotifyIcon(NIM_DELETE, trayiconinfo);
}

// ؒf
void WItalk2::disconnect(void)
{
	m_pCurrentLogWindow = NULL;
	ic.Disconnect();
	SetWindowText(Hwnd(), lgWindows::TheName());
	log_save_log();
	wi_timer_q->cancel(1, 1);		// /x nopM^C}
	set_all();
}

// 낢ݒ
void WItalk2::set_all(void)
{
	_ASSERT( m_pProfileManager );
	toolbar->PressButton(rCommandLogAutoScroll, menu.IsChecked(rCommandLogAutoScroll));
	toolbar->PressButton(rCommandOtherTopMost, menu.IsChecked(rCommandOtherTopMost));

	m_pProfileManager->Write("DisableAutoScrollWhenMinimized", menu.IsChecked(rCommandLogDisableAutoScrollWhenMinimized));
	m_pProfileManager->Write("EnableKillName", DialogKillName::killname);
	m_pProfileManager->Write("IsMainWindowTopMost", menu.IsChecked(rCommandOtherTopMost));
#ifdef	USE_EMACS_KEYBIND
	m_pProfileManager->Write("UseEmacsKeyBinding", menu.IsChecked(rCommandOtherEmacsKeyBinding));
#endif
	m_pProfileManager->Write("UsersUpdate",infoUpdate);

	SetWindowPos(Hwnd(), menu.IsChecked(rCommandOtherTopMost) ? HWND_TOPMOST : HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

#ifdef	USE_EMACS_KEYBIND
  iv_use_emacs_key_binding(menu.IsChecked(rCommandOtherEmacsKeyBinding));
#endif

  set_tooltip();
}

// tHgƔwiF̐ݒ
void WItalk2::set_font_and_bkcolor(BOOL does_set_font)
{
  iv_set_font_and_bkcolor(does_set_font);
  if (does_set_font) {
    combo_connectto_set_font();
    url_set_font();
  }
}


WItalk2::WItalk2(HWND _hwnd) : lgMainWindow(_hwnd)/*, registry(REGISTRY_ROOT)*/
{
	szItalkHost = NULL;	      // modified by TYM
	isConnectionActive = FALSE; // modified by TYM
	SetHelp("WITALK2.HLP", 0);	// Waffle 0.1.7
	hPopupMenu = LoadMenu((HINSTANCE)GetWindowLongPtr(Hwnd(), GWL_HINSTANCE), MAKEINTRESOURCE(rMenuPopup));	// Waffle 0.1.10
	hPopupMenu = GetSubMenu(hPopupMenu, 0);
	trayiconinfo = 0;
	m_pProfileManager = NULL;
	strcpy( m_strProfileInitDir, ".\\" );
	m_bFirstProfileDlg = TRUE;
	isCheckedAutoScroll = !!menu.IsChecked(rCommandLogAutoScroll);
	m_pCurrentLogWindow = NULL;
}

int WItalk2::wmCreate(CREATESTRUCT * cs )
{
	WItalk2CreateParam* pParam = (WItalk2CreateParam*)cs->lpCreateParams;
	m_pProfileManager = pParam->pProfileManager;
	// 
	is_first_wmSetFocus = true;
	ic.SetItalkConnectionNotify(this);
	for (int i = 0; i < ArrayNum(hwnd_property); i++)
		hwnd_property[i] = NULL;
	menu.SetWindow(Hwnd());
	haccel_main = LoadAccelerators(lgWindows::hInst(), MAKEINTRESOURCE(rAcceleratorMain));
	message_init();
	dialog_users_init();

	// Waffle 0.2.0: dze[ȕ
	{
		for (int j = 0; j < 256; j++){ telegramDeliveryTableUserno[j] = 0; telegramDeliveryTableHwnd[j] = 0; }
			telegramDeliveryMembers = 0;
	}

	// wiFEF̓ǂݍ
	m_pProfileManager->Read("FoColorInput", (int &)foColorInput, GetSysColor(COLOR_WINDOWTEXT));
	m_pProfileManager->Read("BkColorInput", (int &)bkColorInput, GetSysColor(COLOR_WINDOW));
	m_pProfileManager->Read("BkColorLog",	(int &)bkColorLog, GetSysColor(COLOR_WINDOW));
	m_pProfileManager->Read("BkColorLogPublic", (int &)bkColorLogPublic, GetSysColor(COLOR_WINDOW));
	m_pProfileManager->Read("BkColorLogPrivate", (int &)bkColorLogPrivate, GetSysColor(COLOR_WINDOW));

	// 낢EBhE
	statusbar = new
		lgcStatusbar(CreateStatusWindow(WS_CHILD | WS_VISIBLE | SBS_SIZEGRIP,
						NULL, Hwnd(), 0));
	toolbar = lgcToolbar::newCreate(Hwnd(), rToolbar16, rToolbar16);

	splitbar_create();
	iv_create();
	splitbar_init_after_iv();
	combo_connectto_create();
	url_create();

	// EBhËʒu̒
	RECT rc;
	GetWindowRect(Hwnd(), &rc);
	if (m_pProfileManager->Read("PositionMain", rc, rc)) {
		MoveWindow(&rc, (BOOL)FALSE);
		MoveWindowVisible();
	}

	wmSize(SIZE_RESTORED, rc.right, rc.bottom);

	splitbar_read_registry();

	freeeditmode = false;

	// URL ֘A
	m_pProfileManager->Read("URLColoring", DialogURL::url_coloring, true);
	m_pProfileManager->Read("URLClickToOpen", DialogURL::url_clicktoopen, true);
	m_pProfileManager->Read("URLClickMode", DialogURL::url_clickmode, false);
	m_pProfileManager->Read("BrowserExecMode", DialogURL::url_execmode, false);
	m_pProfileManager->Read("BrowserBufExecMode", DialogURL::url_bufexecmode, false);

	// Paranoia1
	m_pProfileManager->Read("DebugEchoback", DialogParanoia1::paranoia1_debugechoback, false);
	m_pProfileManager->Read("ShowTip", DialogParanoia1::paranoia1_showtip, false);
	m_pProfileManager->Read("ShowWA", DialogParanoia1::paranoia1_showwa, false);
	DialogParanoia1::paranoia1_outputtolog = false; //m_pProfileManager->Read("OutputToLog", DialogParanoia1::paranoia1_outputtolog, false);
	DialogParanoia1::paranoia1_outputtoprivatelog = true; //m_pProfileManager->Read("OutputToPrivateLog", DialogParanoia1::paranoia1_outputtoprivatelog, true);
	DialogParanoia1::paranoia1_outputtopubliclog = true; //m_pProfileManager->Read("OutputToPublicLog", DialogParanoia1::paranoia1_outputtopubliclog, true);
	m_pProfileManager->Read("EnableSSLSwitching", DialogParanoia1::paranoia1_sslswitching, true);
	m_pProfileManager->Read("EnableXnop", DialogParanoia1::paranoia1_xnop, true);
	m_pProfileManager->Read("XnopInterval", DialogParanoia1::paranoia1_xnop_interval, 50);
	if (DialogParanoia1::paranoia1_xnop_interval < 10) DialogParanoia1::paranoia1_xnop_interval = 10;
	if (DialogParanoia1::paranoia1_xnop_interval > 86400) DialogParanoia1::paranoia1_xnop_interval = 86400;

	// 낢
	int	value;
	menu.Check(rCommandLogAutoScroll);
	m_pProfileManager->Read("DisableAutoScrollWhenMinimized", value, FALSE);
	menu.Check(rCommandLogDisableAutoScrollWhenMinimized, value);
	m_pProfileManager->Read("EnableKillName", DialogKillName::killname, TRUE);
	m_pProfileManager->Read("IsMainWindowTopMost", value, FALSE);
	menu.Check(rCommandOtherTopMost, value);
	m_pProfileManager->Read("UseEmacsKeyBinding", value, FALSE);
	menu.Check(rCommandOtherEmacsKeyBinding, value);

	set_font_and_bkcolor();
	set_all();
	read_registry_for_ping();
	srand((unsigned int)time(NULL));

	// Waffle 0.2.0d:  Users ꗗ_CAO\ŐĂ
	if (!hwnd_dialog_users){
		SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);		// 
		/*lgRegistry	registry(REGISTRY_ROOT);*/
		BOOL does_auto_show_users;
		m_pProfileManager->Read("AutoShowUsers", does_auto_show_users, TRUE);
		if (!does_auto_show_users) SendMessage(Hwnd(), WM_COMMAND, rCommandOtherUsers, 0);	// \ݒłȂȂgOŔ\
	}

	// Waffle 0.2.1b: ^XNgCɃACRo^
	int		tasktrayIcon_, tasktrayStore_;
	m_pProfileManager->Read("TasktrayIcon", tasktrayIcon_, false); 
	m_pProfileManager->Read("TasktrayStore", tasktrayStore_, false);
	tasktrayIcon = (tasktrayIcon_) ? true : false; tasktrayStore = (tasktrayStore_) ? true : false;
	if (tasktrayIcon) registerIconOnTasktray();

	// Waffle 0.2.1d: JIS-patch Kp
	int		sendJIS_;
	m_pProfileManager->Read("SendJIS", sendJIS_, false);
	sendJIS = (sendJIS_) ? true : false;

	// Waffle 0.2.1c: ^XNo[ďʒm
	s_uTaskbarRestart = RegisterWindowMessage(TEXT("TaskbarCreated"));

	// ^C}L[쐬
	wi_timer_q = new TimerQueue(Hwnd());	// ^C}L[

	/* Waffle 0.1.9: nhݒ肳ĂȂ (CXg[㓙) nh̓͂𑣂 */
	char buf[BUFSIZE];
	m_pProfileManager->Read("Handle", buf, sizeof(buf), LoadString(rStringDefaultHandle));
	if (strcmp(buf, LoadString(rStringDefaultHandle)) == 0){	// nhݒ肳ĂȂ
		switch(MessageBox(0, LoadString(rStringReqDefineHandle), "WItalk2 Initializer", MB_OKCANCEL | MB_ICONWARNING)){
		case IDOK:
			wmCommand(0, rCommandConnectionSetting, 0);
		case IDCANCEL:
		default:
			break;
		}
	}

	// Waffle 0.2.0b: NIvVŎڑw肳Ă玩ڑ
	if (strstr(commandLine, "/connect=") != 0){
		char	connectServer[BUFSIZE];
		int	len;
		strcpy(connectServer, strstr(commandLine, "/connect=")+9); len = strlen(connectServer);
		// ڑEBhEɂ̕񂪓͂Aڑ{^ꂽƂɂ
		combo_connectto_connect(connectServer);
	}

	return 0;
}

WItalk2::~WItalk2()
{
	disconnect();
	if (!IsIconic(Hwnd()) && !IsZoomed(Hwnd())) {
		RECT rc;
		GetWindowRect(Hwnd(), &rc);
		if( m_pProfileManager ){
			m_pProfileManager->Write("PositionMain", rc);
		}
	}

	message_end();

	splitbar_destroy();
	iv_destroy();
	url_destroy();
	combo_connectto_destroy();
	dialog_users_end();

	delete toolbar;
	delete statusbar;
	
	// ^C}~
	wi_timer_q->cancel(0, 0);
	delete wi_timer_q;

	// Waffle 0.2.1b: ^XNgCACR폜
	if (true) unregisterIconFromTasktray();

	// Waffle 0.2.0e: S\PbgEBhEޯێw
	lgSocket::bukkoroAllSocketWindow();	// ȂƁAExitProcess() ĂXbhcĂ܂

	delete m_pProfileManager;
	ExitProcess(0);	// Waffle 0.2.0e: ȍ~̏ GPF 悤Ȃ̂ŁAɏIĂ܂

	PostQuitMessage(0);	// Ԃ񂱂̂Ɩ߂Ă僁bZ[W[v𔲂Ǝv

}

int WItalk2::wmMenuSelect(UINT item, UINT flags, HMENU hmenu)
{
	if (flags & MF_POPUP) {
		if (item == 0) {		// ڑ(C)
			menu.Enable(rCommandConnectionDisconnect, ic.IsValid() || ic.IsConnecting());
			menu.Enable(rCommandConnectionDisconnectNil, ic.IsValid() || ic.IsConnecting());	// Waffle 0.1.5
		} else if (item == 1) {	// ҏW(E)
			ItalkView *iv = iv_get_focused();
			BOOL is_selected	= iv->Re.IsSelected();
			BOOL can_paste	= iv->Re.CanPaste();
			BOOL read_only	= iv != iv_input;
			menu.Enable(rCommandEditUndo	 , iv->Re.CanUndo());
			menu.Enable(rCommandEditCut	 , is_selected && !read_only);
			menu.Enable(rCommandEditCopy	 , is_selected);
			// Waffle 0.1.7: JbgAhy[Xg͓̓EBhEɑ΂Ă̂ݍs
			menu.Enable(rCommandEditPaste	 , /* can_paste */ iv_input->Re.CanPaste());
			menu.Enable(rCommandEditQuotedPaste, /* can_paste */ iv_input->Re.CanPaste());
			menu.Enable(rCommandEditDelete	 , is_selected && !read_only);
			menu.Enable(rCommandEditSendToItalk, is_selected);
			menu.Enable(rCommandClearClipboard, iv_input->Re.CanPaste());
			// Waffle 0.1.5: OEBhEɃtH[JXĂ\tM͋
			menu.Enable(rCommandEditPasteSendToItalk, /* can_paste */ iv_input->Re.CanPaste() & ic.IsConnecting());
			menu.Enable(rCommandEditQuotedPasteSendToItalk, /* can_paste */ iv_input->Re.CanPaste() & ic.IsConnecting());
		} else if (item == 3) {	// ̑(O)
			// Waffle 0.2.3: j[폜E_CAOɓ
			//menu.Check(rCommandOtherOpenURL, url_is_displaied());
		}
	}
	return lgMainWindow::wmMenuSelect(item, flags, hmenu);
}

// ĕ``
int WItalk2::wmPaint()
{
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(Hwnd(), &ps);
	paint(hdc);
	EndPaint(Hwnd(), &ps);
	return 0;
}

// tH[JX󂯎
int WItalk2::wmSetFocus(HWND /* hwnd_lose_focus */)
{
	// Waffle 0.1.1: ڑłȂ΍ŏ̃tH[JXƓ
	if (is_first_wmSetFocus || !isConnectionActive) { 
		SetFocus(hwnd_combo_connectto);
	} else {
		SetFocus(iv_input->Re.Hwnd());
	}
	is_first_wmSetFocus = false;
	//lgcRichEdit::lockSelrange(); lgcRichEdit::selrange.clear(); lgcRichEdit::unlockSelrange();
	SendMessage(hwnd_dialog_users, WM_COMMAND, rCommandDialogUsersMoveTop, 0);
	return 0;
}

// EBhETCYω
int WItalk2::wmSize(int size_type, int width, int height)
{
	// ACRꂽI[gXN[ off
	if (size_type == SIZE_MINIMIZED && menu.IsChecked(rCommandLogDisableAutoScrollWhenMinimized)) {
		menu.Check(rCommandLogAutoScroll, FALSE);
		set_all();
	}

	// ACRꂽ^XNo[
	if (size_type == SIZE_MINIMIZED && tasktrayIcon && tasktrayStore){
		// WS_EX_TOOLWINDOW ݒ肵 ALT+TAB Ő؂ւȂ悤ɂ
		SetWindowLongPtr(Hwnd(), GWL_EXSTYLE, (GetWindowLongPtr(Hwnd(), GWL_EXSTYLE) | WS_EX_TOOLWINDOW) & (~WS_EX_APPWINDOW));
		// ^XNo[ɍڂȂ悤ɂ
		taskbarDelete(Hwnd());
	} else if (size_type == SIZE_RESTORED){
		// ^XNo[ɍڂ
		taskbarAdd(Hwnd());
	}

	lgMainWindow::wmSize(size_type, width, height);
	combo_connectto_resize();
	url_resize();
	splitbar_resize();

	InvalidateRect(toolbar->Hwnd(), NULL, TRUE);
	UpdateWindow(toolbar->Hwnd());

	HDC hdc = GetDC(Hwnd());
	paint(hdc);
	ReleaseDC(Hwnd(), hdc);
	return 0;
}

// \PbgCxg
void WItalk2::Connected(ItalkConnection * ic)
{
	lineCounter = 0; isConnectionActive = TRUE;
	servercaps_subroom = servercaps_ssl = servercaps_xnop = false;
	italk_info.server.is_inid = false;
	combo_connectto_connected();
	message_connected();
	dialog_users_connected();
	set_all();
}

void WItalk2::FailedToConnect(ItalkConnection * /* ic */, int wsaerrno)
{
  combo_connectto_failed_to_connect();
  show_error_message(ic.GetErrorMessage(wsaerrno));
}

void WItalk2::Disconnected(ItalkConnection * /* ic */)
{
	show_error_message(LoadString(rStringDisconnected));
	isConnectionActive = FALSE;
}

void WItalk2::ConnectionClosed(ItalkConnection * /* ic */)
{
	// ؒfOɒǉ
	add_log(LoadStringW(rStringApndConnectionClosed));
	// Waffle 0.2.0d: ʓdEBhEɂ "*** Connection closed. ***" ǉ
	{
		for (int i = 0; i < telegramDeliveryMembers; i++) PostMessage(telegramDeliveryTableHwnd[i], WM_COMMAND, rCommandAppendLog, (LPARAM)LoadStringW(rStringApndConnectionClosed));
	}
	// SSL
	if (ic.sslMode) {
		SSL_shutdown(ic.ssl); closesocket(ic.getSocket());
		ic.sslMode = false;
		ic.sslSwitching = false;
	}
	disconnect();
	combo_connectto_closed();
	isConnectionActive = FALSE;
}

void WItalk2::Error(ItalkConnection * /* ic */, int wsaerrno)
{
	combo_connectto_error();
	show_error_message(ic.GetErrorMessage(wsaerrno));
}

void WItalk2::DataArrived(ItalkConnection * /* ic */, const wchar_t *data)
{
	add_log(data);
}

// Users
int WItalk2::wmDialogNotify_DialogUsers(BOOL does_hide)
{
	dialog_users_notify(does_hide);
	return 0;
}

// Fς
int WItalk2::wmDialogNotify_DialogColor(BOOL is_lf_updated)
{
	set_font_and_bkcolor(is_lf_updated);
	read_registry_combo_color();
	combo_connectto_redraw();
	url_redraw();
	dialog_users_update();

	return 0;
}

// nhς
int WItalk2::wmDialogNotify_DialogItalkServer(BOOL does_read_registry)
{
	if (does_read_registry) {
		combo_connectto_read_registry();
		read_registry_for_ping();
	}
	return 0;
}

// Kill Name ς
int WItalk2::wmDialogNotify_DialogKillName(BOOL does_read_registry)
{
	if (does_read_registry)
		read_registry_for_kill_name();
	return 0;
}

// ς
int WItalk2::wmDialogNotify_DialogSounds(BOOL does_read_registry)
{
	if (does_read_registry) read_registry_for_ping();
	return 0;
}

// Users Options ς
int WItalk2::wmDialogNotify_DialogUsersOptions(BOOL does_update)
{
	if (does_update) dialog_users_update();
	return 0;
}

// Other ς
int WItalk2::wmDialogNotify_DialogOther(BOOL does_read_registry)
{
	return 0;
}

// Effects ς
int WItalk2::wmDialogNotify_DialogWindows2000(BOOL does_read_registry)
{
	return 0;
}

// Telegram ς
int WItalk2::wmDialogNotify_DialogTelegram(BOOL does_read_registry)
{
	return 0;
}

// URL ς
int WItalk2::wmDialogNotify_DialogURL(BOOL does_read_registry)
{
	return 0;
}

// Paranoia/1 ς
int WItalk2::wmDialogNotify_DialogParanoia1(BOOL does_read_registry)
{
	return 0;
}

// EDIT Rg[̐F
HBRUSH WItalk2::wmCtlColorEdit(HDC hdc, HWND hwnd)
{
	return ctl_color(hdc);
}

// 
int WItalk2::wmClose()
{
	// JĂTu[EBhEL^
#if 0
	map<string, string>	roomlst;
	for (int i = 0; i < telegramDeliveryMembers; i++) {
		TelegramWndProcData*	twpd = (TelegramWndProcData*)GetWindowLongPtrA(telegramDeliveryTableHwnd[i], GWL_USERDATA);
		if (twpd) {
			
		}
	}
#endif
	// IJn
	if (terminate_log_thread()) return DefWindowProc(Hwnd(), WM_CLOSE, 0, 0);
	PostMessage(Hwnd(), WM_CLOSE, 0, 0);
	return 0;
}

// WM_COMMAND
int WItalk2::wmCommand(int /* notify_code */, int id, HWND hwnd_control)
{
	if (hwnd_control == hwnd_button_connectto)
		return wmCommand_ButtonConnectTo();
	if (hwnd_control == hwnd_button_url)
		return wmCommand_ButtonOpenURL();
	if (id >= rCommandTelegramWindowBase && id < rCommandTelegramWindowBase + 256){
		TelegramWindowRestore(id - rCommandTelegramWindowBase);
		return 0;
	}
	if (id >= rCommandBacklogWindowBase && id < rCommandBacklogWindowBase + (signed)backlogList.size()){
		BacklogWindowRestore(id - rCommandBacklogWindowBase);
		return 0;
	}
	switch (id) {
#define c(x) case rCommand##x: return wmCommand_##x()
	c(ConnectionConnect);					// ڑ
	c(ConnectionDisconnect);				// ؒf
	c(ConnectionSetting);					// ݒ
	c(EditUndo);							// ҏW
	c(EditCut);								//
	c(EditCopy);							//
	c(EditPaste);							//
	c(EditDelete);							//
	c(EditQuotedPaste);						// pt\t
	c(EditSendToItalk);						// I͈͂ Italk ֑M
	c(EditPasteSendToItalk);				// Nbv{[h̓e𑗐M
	c(EditQuotedPasteSendToItalk);			// Nbv{[ḧptM
	c(LogAutoScroll);						// I[gXN[邩ǂ
	c(LogDisableAutoScrollWhenMinimized);	// ŏɃI[gXN[It
	c(OtherTelegram);						// d񃂁[hɓ
	c(OtherTopMost);						// ɈԎOɕ\
	c(OtherUsers);							// OCĂl̈ꗗ\
	c(OtherOpenURL);						// italk ̉bŏo URL ̈ꗗ\
	c(OtherEmacsKeyBinding);				// Emacs L[oCfBO
	c(OtherSetting);						// ̑̐ݒ
	c(ContextHelp);							// wv (Waffle 0.1.7)
	c(HelpAbout);							// About ...
	c(KeyEnter);							// Enter ꂽ
	c(KeyShiftEnter);						// Shift+Enter ꂽ
	c(KeyTab);								// Tab ꂽ
	c(KeySTab);								// Shift+Tab ꂽ
	c(KeyCTab);								// Control+Tab ꂽ
	c(KeyCSTab);							// Control+Shift+Tab ꂽ
	c(KeyCH);								// Control+H ꂽ
	c(KeyDown);								// ꂽ
	c(KeyMNext);							// Page Down ꂽ
	c(KeyMPrior);							// Page Up ꂽ
	c(KeyCF6);								// Control+F6 ꂽ
	c(Quit);								// [[
	c(FileSend);							// t@CM
	c(FileReceive);							// t@CM
	c(OpenBackLogWindow);
	c(AllWindowsRestore);					// SEBhEA
	c(MainWindowRestore);					// EBhEA
	c(ToggleFreeEdit);						// RҏW[h
	c(ClearClipboard);						// Nbv{[hNA
	// for profile (by sept 2002/6/4)
	c(ProfileNew);							//VKvt@C̍쐬(KvH)
	c(ProfileOpen);							//vt@CJ
	c(ProfileSave);							//vt@C㏑ۑ
	c(ProfileSaveAs);						//vt@C𖼑Otĕۑ
	c(ProfileAssociation);					//vt@C֘At
	c(ClearBuffer);							// Oobt@NA
#undef c
  }
  return 0;
}

// t@CM
int	WItalk2::wmCommand_FileSend()
{
#if 0
	MessageBox(0, "Send", "Send", MB_OK);
#endif
	return 0;
}

// t@CM

int WItalk2::wmCommand_FileReceive()
{
#if 0
	MessageBox(0, "Receive", "Receive", MB_OK);
#endif
	return 0;
}

// Nbv{[hNA
int WItalk2::wmCommand_ClearClipboard()
{
	char	clipclearstr[BUFSIZE];
	::LoadString(hinstance, rStringClearClipboard, clipclearstr, sizeof(clipclearstr));
	if (OpenClipboard(0)){ EmptyClipboard(); CloseClipboard(); }
	if (statusbar) {
		statusbar->SetText(clipclearstr);
	}

	return 0;
}


// RҏW[hgO
int WItalk2::wmCommand_ToggleFreeEdit()
{
	char	freeeditstr[BUFSIZE];
	::LoadString(hinstance, rStringEnterFreeEdit, freeeditstr, sizeof(freeeditstr));
	freeeditmode = !freeeditmode;
	if (statusbar) if (freeeditmode) {
		statusbar->SetText(freeeditstr);
		statusbar->SetColor(RGB(0, 0, 0), RGB(255, 255, 0), false);
	} else {
		statusbar->SetText("");
		statusbar->SetColor();
	}
	menu.Check(rCommandToggleFreeEdit, freeeditmode);
	return 0;
}

// obt@NA
int WItalk2::wmCommand_ClearBuffer ()
{
	if (MessageBox(hwnd, lgWindows::LoadString(rStringQuestionClearBuffer), lgWindows::TheName(), MB_OKCANCEL | MB_ICONQUESTION | MB_DEFBUTTON2) == IDOK) {
		iv_log_public->Re.clearBuffer();
	}
	return 0;
}


// EBhEA
int WItalk2::wmCommand_MainWindowRestore()
{
	// EBhEX^C WS_EX_TOOLWINDOW  WS_EX_APPWINDOW ɕύX
	SetWindowLongPtr(Hwnd(), GWL_EXSTYLE, (GetWindowLongPtr(Hwnd(), GWL_EXSTYLE) | WS_EX_APPWINDOW) & (~WS_EX_TOOLWINDOW));
	// EBhEA
	ShowWindow(Hwnd(), SW_RESTORE); SetFocus(Hwnd());
	return 0;
}

// SdEBhEA
void WItalk2::AllTelegramWindowsRestore(void)
{
	for (int i = 0; i < telegramDeliveryMembers; i++) TelegramWindowRestore(i);
}

// dEBhEA
void WItalk2::TelegramWindowRestore(int n)
{
	// EBhEX^C WS_EX_TOOLWINDOW  WS_EX_APPWINDOW ɕύX
	SetWindowLongPtr(telegramDeliveryTableHwnd[n], GWL_EXSTYLE, (GetWindowLongPtr(telegramDeliveryTableHwnd[n], GWL_EXSTYLE) | WS_EX_APPWINDOW) & (~WS_EX_TOOLWINDOW));
	// EBhEA
	ShowWindow(telegramDeliveryTableHwnd[n], SW_RESTORE); SetFocus(telegramDeliveryTableHwnd[n]);
}

// obNOEBhEA
void WItalk2::BacklogWindowRestore(int n)
{
	if (!backlogList[n]) return;
	// EBhEX^C WS_EX_TOOLWINDOW  WS_EX_APPWINDOW ɕύX
	SetWindowLongPtr(backlogList[n]->getHwnd(), GWL_EXSTYLE, (GetWindowLongPtr(backlogList[n]->getHwnd(), GWL_EXSTYLE) | WS_EX_APPWINDOW) & (~WS_EX_TOOLWINDOW));
	// EBhEA
	ShowWindow(backlogList[n]->getHwnd(), SW_RESTORE); SetFocus(backlogList[n]->getHwnd());
}

// SEBhEA
int WItalk2::wmCommand_AllWindowsRestore(void)
{
	AllTelegramWindowsRestore();
	wmCommand_MainWindowRestore();
	return 0;
}

// ^XNgC
int WItalk2::wmCommand_TasktrayNotify(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(lParam){
	case WM_RBUTTONDOWN:	PopupTasktrayMenu(hwnd); break;
	case WM_LBUTTONDBLCLK:	wmCommand_AllWindowsRestore(); break;
	}
	return 0;
}

// ^XNgCŃ|bvAbvj[o
void WItalk2::PopupTasktrayMenu(HWND hwnd)
{
	HMENU	hMenuTrayFloat, hMenuTrayTop, hMenuTray;
	hMenuTrayFloat = CreateMenu(); hMenuTrayTop = CreateMenu();
	AppendMenu(hMenuTrayFloat, MF_STRING, rCommandAllWindowsRestore, LoadString(rStringTasktrayRestoreAllWindows));
	AppendMenu(hMenuTrayFloat, MF_SEPARATOR, 0, NULL);
	{
		char	wndtitle[BUFSIZE];
		GetWindowText(hwnd, wndtitle, sizeof(wndtitle));
		AppendMenu(hMenuTrayFloat, MF_STRING, rCommandMainWindowRestore, wndtitle);
	}
	if (telegramDeliveryMembers){
		AppendMenu(hMenuTrayFloat, MF_SEPARATOR, 0, NULL);
		for (int i = 0; i < telegramDeliveryMembers; i++){
			char	wndtitle[BUFSIZE];
			GetWindowText(telegramDeliveryTableHwnd[i], wndtitle, sizeof(wndtitle));
			AppendMenu(hMenuTrayFloat, MF_STRING, rCommandTelegramWindowBase + i, wndtitle);
		}
	}
	if (backlogList.size()){
		AppendMenu(hMenuTrayFloat, MF_SEPARATOR, 0, NULL);
		for (unsigned int i = 0; i < backlogList.size(); i++) if (backlogList[i]){
			char	wndtitle[BUFSIZE];
			GetWindowText(backlogList[i]->getHwnd(), wndtitle, sizeof(wndtitle));
			AppendMenu(hMenuTrayFloat, MF_STRING, rCommandBacklogWindowBase + i, wndtitle);
		}
	}
	AppendMenu(hMenuTrayFloat, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenuTrayFloat, MF_STRING, rCommandQuit, LoadString(rStringTasktrayExit));
	AppendMenu(hMenuTrayTop, MF_POPUP, (UINT)hMenuTrayFloat, "&File");
	POINT	cursorPoint;
	GetCursorPos(&cursorPoint);
	hMenuTray = GetSubMenu(hMenuTrayTop, FALSE);
	// Waffle 0.2.2beta6: j[Ȃ̂C
	SetForegroundWindow(hwnd);
	TrackPopupMenu(hMenuTray, 0, cursorPoint.x, cursorPoint.y, 0, hwnd, NULL);
	PostMessage(hwnd, WM_NULL, 0, 0);
	DestroyMenu(hMenuTrayFloat); DestroyMenu(hMenuTrayTop); DestroyMenu(hMenuTray);
}

// ۂɐڑ
int WItalk2::wmCommand_ButtonConnectTo(void)
{
  SetFocus(hwnd_combo_connectto);
  combo_connectto_connect();
  return 0;
}

// URL J
int WItalk2::wmCommand_ButtonOpenURL(void)
{
	SetFocus(hwnd_combo_url);
	url_open();
	return 0;
}

// Option
int WItalk2::wmCommand_Option(int page)
{
	if (hwnd_property[0]) {
		PropSheet_SetCurSel(hwnd_property[0], 0, page);
		lgWindow::MoveWindowVisible(hwnd_property[0]);
		ShowWindow(hwnd_property[0], SW_SHOW);
		SetForegroundWindow(hwnd_property[0]);
		return 0;
	}
	PROPSHEETPAGE psp[11];
	PROPSHEETHEADER psh;
	SetPropertySheetPage(0, ItalkServer, m_pProfileManager);
	SetPropertySheetPage(1, Color, m_pProfileManager);
	SetPropertySheetPage(2, KillName, m_pProfileManager);
	SetPropertySheetPage(3, Sounds, m_pProfileManager);
	SetPropertySheetPage(4, UsersOptions, m_pProfileManager);
	SetPropertySheetPage(5, Other, m_pProfileManager);
	SetPropertySheetPage(6, Telegram, m_pProfileManager);
	SetPropertySheetPage(7, Windows2000, m_pProfileManager);
	SetPropertySheetPage(8, URL, m_pProfileManager);
	SetPropertySheetPage(9, Paranoia1, m_pProfileManager);
	SetPropertySheetHeader(rIconWItalk2, rStringOptionTitle);
	hwnd_property[0] = (HWND)PropertySheet(&psh);
	return 0;
}

// ڑ
int WItalk2::wmCommand_ConnectionConnect()
{
	combo_connectto_setfocus();
	return 0;
}

// ؒf
int WItalk2::wmCommand_ConnectionDisconnect()
{
	disconnect();
	return 0;
}

// ݒ
int WItalk2::wmCommand_ConnectionSetting()
{
	return wmCommand_Option(0);
}

// ҏW
int WItalk2::wmCommand_EditUndo  () { iv_get_focused()->Re.Undo();	 return 0; }
int WItalk2::wmCommand_EditCut	 () { iv_get_focused()->Re.Cut();	 return 0; }
int WItalk2::wmCommand_EditCopy  () { iv_get_focused()->Re.Copy();	 return 0; }
// Waffle 0.1.7: ̓EBhEɃtH[JXȂĂ\t\
// Waffle 0.1.9: ւ
int WItalk2::wmCommand_EditPaste () { wmCommand_RichEditPaste(0, 0, iv_input, 0);	 return 0; }
int WItalk2::wmCommand_EditDelete() { iv_get_focused()->Re.Delete(); return 0; }

// Waffle 0.1.5: ̓EBhEɃtH[JXȂĂ\tM\ɂ
// Waffle 0.1.9 ւ
int WItalk2::wmCommand_EditPasteToBeSent () { wmCommand_RichEditPaste(0, 1, iv_input, 0); return 0; }


#if 1
// OŃNbv{[hǂ iv_input Ƀy[Xg (Waffle 0.3.1alpha-7)
// s̓y[XgȂ
void WItalk2::wmCommand_RichEditPaste(bool quotation, bool senditalk, ItalkView* iv, wchar_t* prefix)
{
#ifdef	_DEBUG
	witalk2_ptr->statusbar->SetText("DEBUG: Entering paste function.");
#endif
	_ASSERT(m_pProfileManager);
	/* p擾 */
	char	quotation_mark[BUFSIZE];
	m_pProfileManager->Read("QuotationMark", quotation_mark, sizeof(quotation_mark), "> ");
	/* Nbv{[h̓e[Jɓ] */
	BOOL	rOpenClipboard = OpenClipboard(NULL);
	_ASSERT(rOpenClipboard);
	HANDLE	hClipMemory = 0;
	string	cliptext;
	if ((hClipMemory = GetClipboardData(CF_TEXT)) || (hClipMemory = GetClipboardData(CF_OEMTEXT))) {	// MBSeLXg
		LPVOID	pClipMemory = GlobalLock(hClipMemory);
		_ASSERT(pClipMemory); if (!pClipMemory) { CloseClipboard(); return; }
		DWORD	datalen = GlobalSize(hClipMemory);
		_ASSERT(datalen); if (!datalen) { CloseClipboard(); return; }
		char*	_cliptext = new char[datalen+2];
		memcpy(_cliptext, pClipMemory, datalen+1); _cliptext[datalen] = 0;
		GlobalUnlock(hClipMemory); CloseClipboard();
		cliptext.assign(_cliptext); delete [] _cliptext;
	} else if (hClipMemory = GetClipboardData(CF_UNICODETEXT)) {	// UnicodeeLXg
		LPVOID	pClipMemory = GlobalLock(hClipMemory);
		_ASSERT(pClipMemory); if (!pClipMemory) { CloseClipboard(); return; }
		DWORD	datalen = GlobalSize(hClipMemory);
		_ASSERT(datalen); if (!datalen) { CloseClipboard(); return; }
		wchar_t*	wcliptext = new wchar_t[datalen+2]; *(((char*)wcliptext)+datalen) = 0; *(((char*)wcliptext)+datalen+1) = 0;
		memcpy(wcliptext, pClipMemory, datalen);
		GlobalUnlock(hClipMemory); CloseClipboard();
		size_t		wcliptextlen = wcslen(wcliptext);
		size_t		ctextlen = wcstombs(NULL, wcliptext, wcliptextlen+1);
		if (ctextlen <= 0) { delete [] wcliptext; return; }
		char*		_cliptext = (char*)_alloca(ctextlen+1);
		wcstombs(_cliptext, wcliptext, wcliptextlen+1);
		cliptext.assign(_cliptext); delete [] wcliptext;
	} else {
		CloseClipboard(); return;
	}
	/* LFŕ
	 * senditalk == true ŏIs LF ݂Ȃ CRLF ⊮ */
	vector<string>	ct;
	{
		int		curLineend = 0;
		while (true) {
			int		nextLineend = cliptext.find('\n', curLineend);
			if (nextLineend == cliptext.npos) {
				if (curLineend == cliptext.size()) break;	// Nbv{[hI[
				else {	// sȂ񂪍Ōɑ݂Ă
					string	l = cliptext.substr(curLineend);
					if (senditalk) l.append("\r\n");
					ct.push_back(l); break;
				}
			} else {	// s𔺂𔭌
				ct.push_back(cliptext.substr(curLineend, nextLineend-curLineend+1));
				curLineend = nextLineend+1;
			}
		}
	}
#ifdef	_DEBUG
	witalk2_ptr->statusbar->SetText("DEBUG: pasting.");
#endif
	/* y[Xg */
	for (unsigned int i = 0; i < ct.size(); i++) {
		/* sXLbv
		 * Ys CR LF TAB SPACE ȊO̕R[h݂ȂΏsȂ */
		if (ct[i].find_last_not_of("\r\n\t\x20") == ct[i].npos) continue;
		/* MEy[Xg */
		if (senditalk) {
			if (prefix) send_str(prefix);
			if (quotation) send_str(quotation_mark);
			send_str(ct[i].c_str());
		}
		if (quotation) iv->Re.Insert(quotation_mark);
		iv->Re.Insert(ct[i].c_str());
	}
#ifdef	_DEBUG
	witalk2_ptr->statusbar->SetText("DEBUG: quit.");
#endif
}
#else
// OŃNbv{[hǂ iv_input Ƀy[Xg (Waffle 0.1.9 for Windows2000)
// s̓y[XgȂ
void WItalk2::wmCommand_RichEditPaste(int quotation, int senditalk, ItalkView* iv, wchar_t* prefix)
{
	_ASSERT( m_pProfileManager );
	/* pWXg (܂ INI) 擾 */
	wchar_t	quotation_mark[BUFSIZE];
	m_pProfileManager->Read("QuotationMark", quotation_mark, sizeof(quotation_mark), L"> ");
	/* Nbv{[hƂ肠e擾 */
	OpenClipboard(0);
	HANDLE	hClipMemory = GetClipboardData(CF_TEXT);
	if (hClipMemory == 0){ CloseClipboard(); return; }	/* Nbv{[hɃeLXgȂ */
	LPVOID pClipMemory = GlobalLock(hClipMemory);
	if (pClipMemory == 0 || !GlobalSize(hClipMemory)){ CloseClipboard(); return; }	/* O[ö悪 */
	char* pMyCopy = new char[GlobalSize(hClipMemory)+1024];
	memcpy(pMyCopy, pClipMemory, GlobalSize(hClipMemory)+16);
	pMyCopy[GlobalSize(hClipMemory)] = 0;	/* Ôߖ NULL */
	int	buflen;
	char* pMyCopyUni = new char[buflen = GlobalSize(hClipMemory)*3+2048];
	GlobalUnlock(hClipMemory);
	CloseClipboard();

	// Waffle 0.2.0d: y[Xg[`
	wchar_t*	str = (wchar_t*)pMyCopyUni;
	{
		for (char *p = pMyCopy, *lastend = pMyCopy; ;){
			if (*p == 0x0A || *p == 0x0D || *p == 0){	/* s܂͕I[𔭌 */
				int		slen = (int)p - (int)lastend;
				if (slen > 0){		/* s 0 łȂ */
					char oldp = *p; *p = 0;		/* ܂ܔs̍ŏ̃oCg NULL ɂĂ */
					/* zCgXy[X܂łȂsȂ瑗MȂ */
					bool	isWhitespaceOnly = true;
					for (char* x = lastend; *x != 0; x++){
						if (*x != 0x0A && *x != 0x0D && *x != 0x20 && *x != 0x09){ isWhitespaceOnly = false; break; }
					}
					if (!isWhitespaceOnly || !senditalk){
						int convertedlen = mbstowcs(str, lastend, buflen);
						if (convertedlen > 0){	/* ϊłȂĂȂ */
							str[convertedlen] = 0;
							if (quotation) iv->Re.Insert(quotation_mark);	/* py[Xg */
							iv->Re.Insert(str);								/* wchar y[Xg */
							if (oldp || senditalk || quotation) iv->Re.Insert(L"\r\n");		/* ŉsy[Xg */
							if (senditalk){		/* Msꍇ */
								if (prefix) send_str(prefix);				/* ʓd /p user ̑OuKv */
								if (quotation) send_str(quotation_mark);	/* p𑗐M */
								send_str(str);								/* s{̑M */
								send_str(L"\r\n");							/* ɉsM */
							}
						} else {
							MessageBox(0, LoadString(rStringErrorMbstowcs), lgWindows::TheName(), MB_OK);
						}
					}
					*p = oldp;		/*  NULL ɂs߂ */
				}
				/* lastend  p XV */
				char* q;
				for (q = p; *q != 0 && (*q == 0x0A || *q == 0x0D); q++) ;		/* s̏I[̎̕܂͕I[܂ŃXLbv */
				if (*q == 0) break;		/* I[ɓBI */
				p = lastend = q;		/* ǂݍݒ|C^i߂ */
				continue;
			}
 			p++;		/* słI[łȂ 1 oCgi߂ */
		}
	}
#if 0	// {̃oCg\邽߂̃fobOpeXgR[h
	char buf[1024], bufUni[2048];
	{ for (UINT i = 0; i < GlobalSize(hClipMemory); i++) sprintf(&buf[i*3], "%.2X ", pMyCopy[i] & 0xFF); }
	MessageBox(0, buf, "Content", MB_OK);
	{ for (UINT i = 0; i < GlobalSize(hClipMemory); i++) sprintf(&buf[i*3], "%.2X ", pMyCopyUni[i] & 0xFF); }
	MessageBox(0, buf, "Content", MB_OK);
#endif
	//iv->Re.MoveCaretToTheLast();
	delete [] pMyCopy; delete [] pMyCopyUni;
	return;
}
#endif

// pt\t
// OŃNbv{[hRs[V[` (Waffle 0.1.9 for Windows2000)
int WItalk2::wmCommand_EditQuotedPaste()
{
	wmCommand_RichEditPaste(1, 0, iv_input, 0);
	return 0;
}

// pt\tM (Waffle 0.1.5)
// Waffle 0.1.9: V[`

int WItalk2::wmCommand_EditQuotedPasteToBeSent()
{
	wmCommand_RichEditPaste(1, 1, iv_input, 0);
	return 0;
}

// I͈͂ Italk ֑M
int WItalk2::wmCommand_EditSendToItalk(ItalkView *_iv, ItalkView* ivInput, wchar_t* prefix)
{
	int	freeeditmode_bak = freeeditmode;
	freeeditmode = false;
	if (ivInput == 0) ivInput = iv_input;
	ItalkView *iv = _iv ? _iv : iv_get_focused();
	CHARRANGE cr;
	iv->Re.GetSel(&cr);
	iv->Re.MoveCaret(cr.cpMin);
	if (cr.cpMax == iv->Re.BeginingOfLineCharFromChar(cr.cpMax))
		cr.cpMax -= 2;
	int last_line = iv->Re.LineFromChar(cr.cpMax);
	int caret_line = 0;
	do {
		if (prefix != 0) send_str(prefix);
		iv_send_current_line(TRUE, iv, FALSE);
		if (caret_line == last_line) break;
		caret_line = iv->Re.LineFromChar(iv->Re.GetCaretIndex());
	} while (caret_line <= last_line);
	freeeditmode = freeeditmode_bak;
	return 0;
}

// Nbv{[h̓e Italk ֑M
int WItalk2::wmCommand_EditPasteSendToItalk()
{
	wmCommand_RichEditPaste(0, 1, iv_input, 0);
	return 0;
}

// Nbv{[h̓eɈpsɒǉ Italk ֑M
int WItalk2::wmCommand_EditQuotedPasteSendToItalk()
{
	wmCommand_RichEditPaste(1, 1, iv_input, 0);
	return 0;
}

#define TOGGLE_MENU(name)			\
int WItalk2::wmCommand_##name()		\
{						\
	menu.ToggleCheck(rCommand##name);		\
	set_all();					\
	return 0;					\
}

// I[gXN[邩ǂ
//TOGGLE_MENU(LogAutoScroll);
int WItalk2::wmCommand_LogAutoScroll()
{
	menu.ToggleCheck(rCommandLogAutoScroll);
	set_all();
	isCheckedAutoScroll = !isCheckedAutoScroll;
	return 0;
}
// ŏɃI[gXN[It
TOGGLE_MENU(LogDisableAutoScrollWhenMinimized);


// eݒ
int WItalk2::wmCommand_LogSaveSetting()
{
	return wmCommand_Option(0);
}

// d񃂁[hɓ
int WItalk2::wmCommand_OtherTelegram()
{
	SetFocus(iv_input->Re.Hwnd());
	return wmCommand_KeyTab();
}

// ɈԎOɕ\
TOGGLE_MENU(OtherTopMost);

// OCĂl̈ꗗ\
int WItalk2::wmCommand_OtherUsers()
{
	dialog_users_show();
	return 0;
}

// Emacs L[oCfBO
TOGGLE_MENU(OtherEmacsKeyBinding);

// italk ̉bŏo URL ̈ꗗ\
int WItalk2::wmCommand_OtherOpenURL()
{
	url_toggle_display();
	set_all();
	return 0;
}

// ̑̐ݒ
int WItalk2::wmCommand_OtherSetting()
{
	return wmCommand_Option(0);
}

// About ...
int WItalk2::wmCommand_About(int page)
{
	return wmCommand_Option(10);
}

// About ...
int WItalk2::wmCommand_HelpAbout()
{
	if (!hAboutWindow) createAboutWindow(hInst(), hwnd);
	return 0;
}

// Shift+Enter ꂽ
//   Waffle 0.2.3: sɉs} (uZǂ)
int WItalk2::wmCommand_KeyShiftEnter()
{
	if (combo_connectto_connect()) return 0;
	if (url_open()) return 0;

	ItalkView* iv = iv_get_focused_only();
	if (iv == iv_input) {
		CHARRANGE	cr;
		iv->Re.GetSel(&cr);
		int		currentLine = iv->Re.LineFromChar(cr.cpMin);
		int		currentLineTop = iv->Re.LineIndex(currentLine);
		cr.cpMin = cr.cpMax = currentLineTop;
		iv->Re.SetSel(&cr);
		iv->Re.Insert("\r\n", TRUE);
		iv->Re.SetSel(&cr);
	}
	return 0;
}

// Enter ꂽ
int WItalk2::wmCommand_KeyEnter()
{
	if (combo_connectto_connect()) return 0;
	if (url_open()) return 0;
	ItalkView *iv = iv_get_focused_only();
	if (iv) {
		if (iv->Re.IsInIsearchMode()) {
			// Ctrl+M ɕϊ (LPARAM ͖)
			SendMessage(iv->Re.Hwnd(), WM_CHAR, 'M' - '@', 0);
			return 0;
		}
	}
	if (iv == iv_input) {
		if (!freeeditmode) {	// RҏW[hłȂΑM
			if (iv_send_current_line()) complete_p(0);
			if (statusbar) statusbar->SetText(NULL);
		} else {				// RҏW[hȂs}
			iv->Re.Insert(L"\r\n", TRUE);
		}
	}
	return 0;
}

// Tab ꂽ
int WItalk2::wmCommand_KeyTab()
{
	if (GetFocus() == iv_input->Re.Hwnd()) complete_p(1); else wmCommand_KeyCTab();
	if (statusbar && !freeeditmode) statusbar->SetText(NULL);
	return 0;
}

// Shift+Tab ꂽ
int WItalk2::wmCommand_KeySTab()
{
	if (GetFocus() == iv_input->Re.Hwnd()) complete_p(-1); else wmCommand_KeyCSTab();
	if (statusbar && !freeeditmode) statusbar->SetText(NULL);
	return 0;
}

// Control+Tab ꂽ
int WItalk2::wmCommand_KeyCTab()
{
	BOOL log   = DialogParanoia1::paranoia1_outputtolog;
	BOOL pulog = DialogParanoia1::paranoia1_outputtopubliclog;
	BOOL prlog = DialogParanoia1::paranoia1_outputtoprivatelog;
	if (GetFocus() == iv_input->Re.Hwnd()) combo_connectto_setfocus();
	else if (combo_connectto_is_focused() && url_is_displaied()) url_setfocus();
	else if (combo_connectto_is_focused() || url_is_focused()) {
		if (pulog) SetFocus(iv_log_public->Re.Hwnd());
		else	   SetFocus(iv_input	 ->Re.Hwnd());
	} else if (GetFocus() == iv_log_public->Re.Hwnd()) {
		SetFocus(iv_input->Re.Hwnd());
	} else {
        SetFocus(iv_input->Re.Hwnd());
	}
	return 0;
}

// Control+Shift+Tab ꂽ
int WItalk2::wmCommand_KeyCSTab(void)
{
	BOOL log   = DialogParanoia1::paranoia1_outputtolog;
	BOOL pulog = DialogParanoia1::paranoia1_outputtopubliclog;
	BOOL prlog = DialogParanoia1::paranoia1_outputtoprivatelog;
	if (GetFocus() == iv_input->Re.Hwnd()) {
		if (pulog) SetFocus(iv_log_public ->Re.Hwnd());
		else if (url_is_displaied()) url_setfocus();
		else combo_connectto_setfocus();
	} else if (GetFocus() == iv_log_public->Re.Hwnd()) {
		if (url_is_displaied()) url_setfocus();
		else combo_connectto_setfocus();
	} else if (url_is_focused())
		combo_connectto_setfocus();
	else
		SetFocus(iv_input->Re.Hwnd());
	return 0;
}

// Control+H ꂽ
int WItalk2::wmCommand_KeyCH()
{
	ItalkView *iv = iv_get_focused_only();
	if (iv) {
		if (iv->Re.IsInIsearchMode() || iv == iv_input) {
			keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), KEYEVENTF_KEYUP, 0);
			keybd_event(VK_BACK, MapVirtualKey(VK_BACK, 0), 0, 0);
			keybd_event(VK_CONTROL, MapVirtualKey(VK_CONTROL, 0), 0, 0);
		}
	}
	return 0;
}

void WItalk2::send_vkey(HWND hwnd, int vkey, BOOL control, BOOL shift, BOOL alt)
{
	BYTE bak[256], state[256];
	GetKeyboardState(bak);
	GetKeyboardState(state);
	state[VK_RCONTROL] = state[VK_LCONTROL] = state[VK_CONTROL] = control ? 0x80 : 0;
	state[VK_RSHIFT] = state[VK_LSHIFT] = state[VK_SHIFT] = shift ? 0x80 : 0;
	state[VK_RMENU] = state[VK_LMENU] = state[VK_MENU] = alt ? 0x80 : 0;
	SetKeyboardState(state);
	SendMessage(hwnd, WM_KEYDOWN, vkey, ((255 & MapVirtualKey(vkey, 0)) << 16));
	SendMessage(hwnd, WM_KEYUP, vkey, ((255 & MapVirtualKey(vkey, 0)) << 16) | 0x80000000);
	SetKeyboardState(bak);
}

//  ꂽ
int WItalk2::wmCommand_KeyDown(void)
{
	if (!iv_key_down()) send_vkey(GetFocus(), VK_DOWN);
	if (statusbar && !freeeditmode) statusbar->SetText(NULL);
	return 0;
}

// Page Down ꂽ
int WItalk2::wmCommand_KeyMNext(void)
{
	if (DialogParanoia1::paranoia1_outputtopubliclog) send_vkey(iv_log_public->Re.Hwnd(), VK_NEXT);
	return 0;
}

// Page Up ꂽ
int WItalk2::wmCommand_KeyMPrior(void)
{
	if (DialogParanoia1::paranoia1_outputtopubliclog) send_vkey(iv_log_public->Re.Hwnd(), VK_PRIOR);
	return 0;
}

// Control+F6 ꂽ
int WItalk2::wmCommand_KeyCF6(void)
{
	BOOL pulog = DialogParanoia1::paranoia1_outputtopubliclog;
	BOOL prlog = DialogParanoia1::paranoia1_outputtoprivatelog;
	if (GetFocus() == iv_input->Re.Hwnd()) {
		if (pulog) SetFocus(iv_log_public ->Re.Hwnd());
		else	    SetFocus(iv_input	   ->Re.Hwnd());
	} else if (GetFocus() == iv_log_public->Re.Hwnd()) {
		SetFocus(iv_input	->Re.Hwnd());
	} else
		SetFocus(iv_input->Re.Hwnd());
	return 0;
}

int WItalk2::wmCommand_OpenBackLogWindow(void)
{
	BackLogWindow* pwnd = new BackLogWindow;
	if( !pwnd->create( (HINSTANCE)GetWindowLongPtr(Hwnd(),GWL_HINSTANCE) , this ) ){
		delete pwnd;
	}
	m_pCurrentLogWindow = pwnd;
	return 0;
}
int WItalk2::wmCommand_ProfileNew(void)
{
	MessageBox( Hwnd(), "hoge", "new", MB_OK );
	return 0;
}
int WItalk2::wmCommand_ProfileOpen(void)
{
	
	char strExt[_MAX_PATH];
	strcpy( strExt, lgWindows::LoadString( IDS_ProfileExt ) );
	char strResultName[_MAX_PATH];
	char strFullName[_MAX_PATH];
	sprintf( strFullName, "*%s", strExt );
	
	///////////////////////////////////////////////////////
	// Filter̍쐬
	// "WItalk2 Profile Files (*.wpf)\0*.wpf\0\0" Ȋ
	char strFilters[BUFSIZE];
	char* p;
	int n;
	n = sprintf( strFilters, "WItalk2 Profile Files (*%s)", strExt );
	strFilters[n] = '\0';
	p = &strFilters[n+1];
	n = sprintf( p, "*%s", strExt );
	p[n] = '\0';
	p[n+1] = '\0';
	p[n+2] = '\0';


	OPENFILENAME ofn = { 
		sizeof(OPENFILENAME),
		Hwnd(), NULL,
		strFilters,
		NULL, 0, 1, strFullName, _MAX_PATH, strResultName, _MAX_PATH,
		m_strProfileInitDir, "Open WItalk2 Profile", OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY, 0, 1,
		strExt, 0, NULL, NULL };
	if( m_bFirstProfileDlg ){
		ofn.lpstrInitialDir = NULL;
	}
	if( !GetOpenFileName( &ofn ) ){
		return 0;
	}
	m_bFirstProfileDlg = FALSE;
	// Store the initial directory for next time
	strcpy( m_strProfileInitDir, strFullName );
	strstr( m_strProfileInitDir, strResultName )[0] = '\0';
	m_strProfileFileName = string(strFullName);

	if( !m_pProfileManager->loadProfile( m_strProfileFileName.c_str() ) ){
		MessageBox( Hwnd(), LoadString(rStringErrorFailedToOpenProfile), lgWindows::TheName(), MB_OK );
	}
	return 0;
}
int WItalk2::wmCommand_ProfileSave(void)
{
	if( !m_pProfileManager->isProfileLoaded() ){
		return wmCommand_ProfileSaveAs();
	}
	if( m_strProfileFileName.empty() ){
		m_strProfileFileName = m_pProfileManager->getProfileFileName();
	}
	if( !m_pProfileManager->saveProfileAs( m_strProfileFileName.c_str() ) ){
		MessageBox( Hwnd(), LoadString(rStringErrorFailedToSaveProfile), lgWindows::TheName(), MB_OK );
	}
	
	return 0;
}
int WItalk2::wmCommand_ProfileSaveAs(void)
{
	char strExt[_MAX_PATH];
	strcpy( strExt, lgWindows::LoadString( IDS_ProfileExt ) );
	char strResultName[_MAX_PATH];
	char strFullName[_MAX_PATH];
	sprintf( strFullName, "*%s", strExt );
	
	///////////////////////////////////////////////////////
	// Filter̍쐬
	// "WItalk2 Profile Files (*.wpf)\0*.wpf\0\0" Ȋ
	char strFilters[BUFSIZE];
	char* p;
	int n;
	n = sprintf( strFilters, "WItalk2 Profile Files (*%s)", strExt );
	strFilters[n] = '\0';
	p = &strFilters[n+1];
	n = sprintf( p, "*%s", strExt );
	p[n] = '\0';
	p[n+1] = '\0';
	p[n+2] = '\0';

	OPENFILENAME ofn = { 
		sizeof(OPENFILENAME),
		Hwnd(), NULL,
		strFilters,
		NULL, 0, 1, strFullName, _MAX_PATH, strResultName, _MAX_PATH,
		m_strProfileInitDir, "Save WItalk2 Profile", OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST, 0, 1,
		strExt, 0, NULL, NULL };
	if( m_bFirstProfileDlg ){
		ofn.lpstrInitialDir = NULL;
	}
	if( !GetSaveFileName( &ofn ) ){
		return 0;
	}
	m_bFirstProfileDlg = FALSE;
	// Store the initial directory for next time
	strcpy( m_strProfileInitDir, strFullName );
	strstr( m_strProfileInitDir, strResultName )[0] = '\0';
	m_strProfileFileName = string(strFullName);

	
	if( !m_pProfileManager->isProfileLoaded() ){
		m_pProfileManager->newProfile();
	}
	if( !m_pProfileManager->saveProfileAs( m_strProfileFileName.c_str() ) ){
		MessageBox( Hwnd(), LoadString(rStringErrorFailedToSaveProfile), lgWindows::TheName(), MB_OK );
	}
	
	return 0;
}
int WItalk2::wmCommand_ProfileAssociation()
{
	int n = MessageBox( Hwnd(), LoadString(rStringQuestionProfileAssociation), lgWindows::TheName(), MB_YESNO | MB_ICONQUESTION);
	if ( n == IDNO ) return 0;

	char exe_name[BUFSIZE];
	if( 0 == GetModuleFileName( NULL, exe_name, BUFSIZE  ) ){
		MessageBox( Hwnd(), LoadString(rStringErrorFailedAssociateProfile), lgWindows::TheName(), MB_OK );
		return 0;
	}

	string command = string( exe_name ) +" -p \"%1\"";
	lgRegistry reg( HKEY_CLASSES_ROOT, "WItalk2.Profile\\shell\\open\\command" );
	reg.Write( NULL, command.c_str() );
	reg.Set( HKEY_CLASSES_ROOT, "WItalk2.Profile" );
	reg.Write( NULL, "WItalk2 Profile" );
	
	reg.Set( HKEY_CLASSES_ROOT, lgWindows::LoadString( IDS_ProfileExt ) );
	reg.Write( NULL, "WItalk2.Profile" );
	return 0;
}
// [[
int WItalk2::wmCommand_Quit(void)
{
	PostMessage(Hwnd(), WM_CLOSE, 0, 0);
	return 0;
}

// italk:// vgRnh
int WItalk2::wmAppConnectTo(const char *handlehostport)
{
	combo_connectto_connect(handlehostport);
	return 0;
}

// Waffle 0.2.0: w肵EBhEnh̃EBhEAw肵EBhEnh̃EBhE
//               ǂꂩ̐̎qł邩ǂ𔻒
bool isDescendant(HWND child, HWND parent)
{
	HWND	parentHwnd = child;

	while(true){
		if (parentHwnd == parent) return true;
		if ((parentHwnd = GetParent(parentHwnd)) == 0) break;
	}
	return false;
}

// _CAO{bNXvpeBANZ[^ׂ̈̃bZ[W
// bZ[W TRUE Ԃ
BOOL WItalk2::ProcessMessage(MSG &msg)
{
	if (hwnd_dialog_users && IsDialogMessage(hwnd_dialog_users, &msg)) return TRUE;
	// `ݒvpeBV[gփbZ[W
	for (int i = 0; i < ArrayNum(hwnd_property); i++){
		if (hwnd_property[i] &&	PropSheet_IsDialogMessage(hwnd_property[i], &msg)){
			if (!PropSheet_GetCurrentPageHwnd(hwnd_property[i])){
				DestroyWindow(hwnd_property[i]);
				hwnd_property[i] = NULL;
			}
			return TRUE;
		}
	}
	// Waffle 0.2.0: ʓdEBhEɃL[{[hANZ[^
	{
		for (int j = 0; j < telegramDeliveryMembers; j++){
			if (isDescendant(msg.hwnd, telegramDeliveryTableHwnd[j])){
				if (TranslateAccelerator(telegramDeliveryTableHwnd[j], haccel_main, &msg)) return TRUE;
			}
		}
	}
	// SPT0.0/Waffle 0.2.1b: obNOEBhEɃANZ[^
	{
		for (unsigned int k = 0; k < backlogList.size(); k++) if (backlogList[k]){
			if (isDescendant(msg.hwnd, backlogList[k]->getHwnd())) if (TranslateAccelerator(backlogList[k]->getHwnd(), haccel_main, &msg)) return TRUE;
		}
	}
	if (TranslateAccelerator(Hwnd(), haccel_main, &msg)) return TRUE;
	return FALSE;
}

// WItalk2 EBhENX̓o^
ATOM WItalk2::Register(void)
{
	WNDCLASS wc;
	wc.style         = 0;
	wc.lpfnWndProc   = WItalk2WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = sizeof(WItalk2 *);
	wc.hInstance	   = lgWindows::hInst();
	wc.hIcon         = LoadIcon(lgWindows::hInst(), MAKEINTRESOURCE(rIconWItalk2));
	wc.hCursor	   = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName  = MAKEINTRESOURCE(rMenu);
	wc.lpszClassName = WC_WITALK2;
	ATOM rrcex = RegisterClass(&wc);
	_ASSERT(rrcex);
	return rrcex;
}

// Waffle 0.2.0: dze[uւ̓o^
void WItalk2::RegisterTelegramDeliveryTable(int userno, HWND hwnd)
{
	if (telegramDeliveryMembers == 255) return;		// Ȃ
	telegramDeliveryTableUserno[telegramDeliveryMembers] = userno; telegramDeliveryTableHwnd[telegramDeliveryMembers] = hwnd;
	telegramDeliveryMembers++;
}

// Waffle 0.2.0: dze[u̍폜
void WItalk2::UnregisterTelegramDeliveryTable(int userno, HWND hwnd)
{
	int		index = -1;
	for (int i = 0; i < telegramDeliveryMembers; i++) if (telegramDeliveryTableUserno[i] == userno){ index = i; break; }
	if (index == -1) return;		// Ȃ
	for (int j = index+1; j < telegramDeliveryMembers; j++){
		telegramDeliveryTableUserno[j-1] = telegramDeliveryTableUserno[j];
		telegramDeliveryTableHwnd  [j-1] = telegramDeliveryTableHwnd  [j];
	}
	telegramDeliveryMembers--;
}

// Waffle 0.2.0: dze[ǔ
//
//   userno ɍvEBhEnhBȂ 0 ԂB
//
HWND WItalk2::SearchTelegramDeliveryTable(int userno)
{
	for (int i = 0; i < telegramDeliveryMembers; i++) if (telegramDeliveryTableUserno[i] == userno) return telegramDeliveryTableHwnd[i];
	return 0;
}


///////////////////////////////////////////////////////////////////////////////
// Windows C^[tF[X

#define lgWindowClass WItalk2

// EBhEvV[W
LRESULT CALLBACK WItalk2WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (!lgwc) switch (message) {
		lgwmCreate;
	} else {
		if (message == WM_SIZE){
			witalk2_ptr->mainWindowWidth = LOWORD(lParam); witalk2_ptr->mainWindowHeight = HIWORD(lParam);
		} else if (message == witalk2_ptr->s_uTaskbarRestart && witalk2_ptr->tasktrayIcon){
			witalk2_ptr->registerIconOnTasktray();	// ^XNgCɍēo^
		}
		switch (message) {
			lgwmDestroy;
			lgwmMenuSelect;
			lgwmPaint;
			lgwmSetFocus;
			lgwmSize;
			lgwmSysColorChange;
			// lgwmNotify;
			lgwmCommand;
			lgwmDrawItem;
			lgwmCtlColorEdit;
			lgwmClose;
		case WM_NOTIFY:
			{
				HWND	notify_hwndfrom = ((LPNMHDR)lParam)->hwndFrom;
				UINT	notify_idfrom = ((LPNMHDR)lParam)->idFrom;
				UINT	notify_code = ((LPNMHDR)lParam)->code;
				//
				// I͈͎ (100%Sł͂Ȃ)
				//
				if (notify_code == EN_SELCHANGE) {
					lgcRichEdit::lockSelrange();
					map<HWND, CHARRANGE>::iterator p = lgcRichEdit::selrange.find(notify_hwndfrom);
					if (p != lgcRichEdit::selrange.end()) {
						CHARRANGE	cr = p->second;
						CHARRANGE	sc = ((SELCHANGE*)lParam)->chrg;
						if (!((cr.cpMax == sc.cpMax && cr.cpMin == sc.cpMin) || (cr.cpMin == sc.cpMax && cr.cpMax == sc.cpMin))) {
							SendMessage(notify_hwndfrom, EM_SETSEL, cr.cpMin, cr.cpMax);
						}
					}
					lgcRichEdit::unlockSelrange();
				}
				if (notify_code != EN_LINK) break;
				//
				// OURLNbNꂽ
				//
				UINT	orgmsg = ((ENLINK*)lParam)->msg;
				switch(orgmsg){
				case WM_LBUTTONDOWN:
					if (DialogURL::url_clickmode) break;
				case WM_LBUTTONDBLCLK:
					CHARRANGE	chrg = ((ENLINK*)lParam)->chrg;
					char*		txtbuf_mb = new char[(chrg.cpMax - chrg.cpMin + 16)*2];
					CHARRANGE	orgsel;
					SendMessage(notify_hwndfrom, EM_EXGETSEL, 0, (LPARAM)&orgsel);
					SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&chrg);
					SendMessage(notify_hwndfrom, EM_GETSELTEXT, 0, (LPARAM)txtbuf_mb);
					SendMessage(notify_hwndfrom, EM_EXSETSEL, 0, (LPARAM)&orgsel);
					witalk2_ptr->statusbar->SetText(string(lgWindows::LoadString(rStringURLOpening)).append(txtbuf_mb).c_str());
					if (lgFiles::OpenURL(txtbuf_mb, DialogURL::url_bufexecmode)) {
						witalk2_ptr->statusbar->SetText(string(lgWindows::LoadString(rStringURLOpened)).append(txtbuf_mb).c_str());
					} else {
						witalk2_ptr->statusbar->SetText(string(lgWindows::LoadString(rStringURLOpenFail)).append(txtbuf_mb).c_str());
					}
					delete [] txtbuf_mb;
				}
				break;
			}
		case WM_POWERBROADCAST:
			if (wParam == PBT_APMQUERYSUSPEND) witalk2_ptr->ic.Disconnect();
			break;
		case WM_QUERYENDSESSION:
			witalk2_ptr->ic.Disconnect();
			break;
		case rCommandTasktrayNotify:
			witalk2_ptr->wmCommand_TasktrayNotify(hwnd, message, wParam, lParam);
			return 0;
		case WM_APP_CONNECT_TO:
			return lgwc->wmAppConnectTo((char *)lParam);

		case WM_DIALOGNOTIFY:
			switch (wParam) {
#define d(x, y) case r##x: return lgwc->wmDialogNotify_##x((y)lParam)
				d(DialogUsers,			BOOL);	// Users
				d(DialogItalkServer,	BOOL);	// nhς
				d(DialogColor,			BOOL);	// Fς
				d(DialogKillName,		BOOL);	// Kill Name ς
				d(DialogSounds,			BOOL);	// ς
				d(DialogUsersOptions,	BOOL);	// Users Options ς
				d(DialogOther,			BOOL);	// Other 
				d(DialogWindows2000,	BOOL);	// Effects ς
				d(DialogURL,			BOOL);  // URL ς
				d(DialogTelegram,		BOOL);	// Telegram ς
				d(DialogParanoia1,		BOOL);	// Paranoia/1 ς
#undef d
			}
			return 0;
		case WM_TIMERQUEUE:
			{
				/* ڑł /x nop 𑗏o^C}Đݒ */
				if (DialogParanoia1::paranoia1_xnop && witalk2_ptr->ic.IsConnecting()) {
					if (sent_handle) witalk2_ptr->send_str(L"/x nop\r\n");
					wi_timer_q->start(1, 1, DialogParanoia1::paranoia1_xnop_interval*1000, nullptr);
				}
				return 0;
			}
		}
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}


// Italk Protocol ̓o^
void RegisterItalkProtocol(const char *path_of_witalk2)
{
	static const BYTE EditFlags[] = { 2, 0, 0, 0 };
	lgRegistry::Write(HKEY_CLASSES_ROOT, "italk", NULL, "URL:Italk Protocol");
	lgRegistry::Write(HKEY_CLASSES_ROOT, "italk", "EditFlags", EditFlags, sizeof(EditFlags));
	lgRegistry::Write(HKEY_CLASSES_ROOT, "italk", "URL Protocol", "");
	char buf[BUFSIZE];
	strcpy(buf, path_of_witalk2);
	strcat(buf, ",0");
	lgRegistry::Write(HKEY_CLASSES_ROOT, "italk\\DefaultIcon", NULL, buf);
	strcpy(buf, path_of_witalk2);
	strcat(buf, " %1");
	lgRegistry::Write(HKEY_CLASSES_ROOT, "italk\\shell\\open\\command", NULL, buf);
}

// ^XNo[ɃEBhEo^ (IE4 ˑ)
bool taskbarAdd(HWND hwnd)
{
	ITaskbarList *pTaskbarList;
    HRESULT         hr;

	CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
    hr = CoCreateInstance(CLSID_TaskbarList, NULL, CLSCTX_INPROC_SERVER, IID_ITaskbarList, (void**)&pTaskbarList);
	if (hr == S_OK) {
		//C^[tFCX̃|C^擾
		pTaskbarList->HrInit();
		hr = pTaskbarList->AddTab(hwnd);
		pTaskbarList->Release();
		CoUninitialize();

		return true;
	} else {
		return false;
	}
}

// ^XNo[EBhE폜 (IE4 ˑ)
bool taskbarDelete(HWND hwnd)
{
	ITaskbarList *pTaskbarList;
    HRESULT         hr;

	CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
    hr = CoCreateInstance(CLSID_TaskbarList, NULL, CLSCTX_INPROC_SERVER, IID_ITaskbarList, (void**)&pTaskbarList);
	if (hr == S_OK) {
		//C^[tFCX̃|C^擾
		pTaskbarList->HrInit();
		hr = pTaskbarList->DeleteTab(hwnd);
		pTaskbarList->Release();
		CoUninitialize();

		return true;
	} else {
		return false;
	}
}

// C
int lgWindows::Main(int argc, char *argv[])
{
	///////////////////////////////////////////////
	// Profile֌W
	BOOL bDoItalkProtocol = TRUE;
	ProfileManager* pProfile = new ProfileManager;
	WItalk2CreateParam create_param;
	create_param.pProfileManager = pProfile;

	strcpy(iniFileName, ".\\waffle.ini");	// INI t@Cݒ

	lgRegistry	registry(REGISTRY_ROOT);
	{
		char	buf[BUFSIZE];
		registry.Read("INISaveFolder", buf, sizeof(buf), ".");
		if (buf[strlen(buf)-1] == 0x5C && strlen(buf) > 1) buf[strlen(buf)-1] = 0;
		strcat(buf, "\\waffle.ini");
		//iniFileName = new char[strlen(buf+1)];
		strcpy(iniFileName, buf);
	}

	// Waffle 0.2.3: dN}ݒ
	int		multiProcess_;
	registry.Read("MultiProcess", multiProcess_, false);

	if (multiProcess_) {
		HWND	prevhwnd = FindWindow(lgWindows::TheName(), NULL);
		if (prevhwnd) {
			// łɋNĂ WItalk2 \ɏo
			SendMessage(prevhwnd, WM_COMMAND, rCommandMainWindowRestore, 0);
			// ͏I
			exit(0);
		}
	}
	///////////////////////////////////////////////////////////////////////////
	// `FbNProfileǂݍ
	// witalk2 -p filename
	if( argc >= 3 ){
		if( argv[1][0] == '-' && argv[1][1] == 'p' ){
			bDoItalkProtocol = FALSE;
			if( !pProfile->loadProfile( argv[2] ) ){
				MessageBox( NULL, LoadString(rStringErrorFailedToOpenProfile), lgWindows::TheName(), MB_OK );
			}
		}
	}

	// Ytt@CXbhi
	initAttachFileSystem();

	RegisterItalkProtocol(argv[0]);
	WItalk2::Register();
	Register_lgcSplitbar();
	Register_lgcAnimation();

	HWND hwnd = CreateWindowEx(NULL, WC_WITALK2, WC_WITALK2, WS_OVERLAPPEDWINDOW,
							   CW_USEDEFAULT, CW_USEDEFAULT, 512, 512,
							   NULL, NULL, lgWindows::hInst(), (void*)&create_param);
	_ASSERT(hwnd);
	int			_does_window_transparent_, _does_users_window_transparent_, _does_telegram_window_transparent_;
	pProfile->Read("EnableMainSemiTransparent", _does_window_transparent_, false);
	pProfile->Read("EnableUsersSemiTransparent", _does_users_window_transparent_, false);
	pProfile->Read("EnableTelegramSemiTransparent", _does_telegram_window_transparent_, false);
	does_window_transparent = (_does_window_transparent_) ? true : false;
	does_users_window_transparent = (_does_users_window_transparent_) ? true : false;
	does_telegram_window_transparent = (_does_telegram_window_transparent_) ? true : false;
	pProfile->Read("WindowMainTransparency", window_transparency, 192);

	firstWindow = hwnd;
	if (windll._SetLayeredWindowAttributes && does_window_transparent){
		SetWindowLongPtr(hwnd, GWL_EXSTYLE, GetWindowLongPtr(hwnd, GWL_EXSTYLE) | WS_EX_LAYERED);
		windll._SetLayeredWindowAttributes(hwnd, 0, window_transparency, LWA_ALPHA);
	}
	char italk_protocol_hostname[BUFSIZE];
	if (2 <= argc && bDoItalkProtocol) {
		char *match_end;
		if (!lgString::DoesMatch(argv[1], "italk:", match_end))
			match_end = argv[1];
		while (*match_end == '/')
			match_end++;
		strcpy(italk_protocol_hostname, match_end);
		while (1) {
			int len = strlen(italk_protocol_hostname);
			if (len <= 0)
				break;
			if (italk_protocol_hostname[len - 1] == '/')
				italk_protocol_hostname[len - 1] = '\0';
			else {
				PostMessage(hwnd, WM_APP_CONNECT_TO, 0,
				(LPARAM)italk_protocol_hostname);
				break;
			}
		}
	}
	
	ShowWindow(hwnd, SW_SHOWDEFAULT);
	UpdateWindow(hwnd);

	MSG msg;
	while (true){
		int result = GetMessage(&msg, NULL, 0, 0);
		if (result == 0 && telegramWindowClose){
			telegramWindowClose = false;
		} else if (result == 0){
			break;
		}
		if (!lgwc->ProcessMessage(msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	// Ytt@CXbhI
	exitAttachFileSystem();

	witalk2_ptr->unregisterIconFromTasktray();

	return msg.wParam;
}

// I locale ݒ肷邽߂̃fobOIvV
LCID	processLocale = 0;

// Locale ݒ
//
//   SetThreadLocale() ֐͖O̒ʂXbhɂ Locale ݒ肵ĂȂ̂ŁA
//   _beginThread łĂ΂Ȃ΂ȂȂ (pȂ)
//
void initLocale()
{
	if (processLocale) SetThreadLocale(processLocale);
}

// eIvV
const char*		OPT_LOCALE_EN			= "/lang=en";			// I "p(č)" P[ŋN
const char*		OPT_DELETE_REG			= "/deleteregs";		// WXg폜


// WinMain ====================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
	// Waffle 0.2.0b: R}hCւ̃|C^ۑ
	commandLine = lpszCmdLine;
	hinstance = hInstance;

    HRESULT rcoinit = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	_ASSERT(rcoinit == S_OK);
	HRESULT oleinit = OleInitialize(NULL);
	_ASSERT(oleinit == S_OK);
	BOOL	ratlinit = AtlAxWinInit();
	_ASSERT(ratlinit);


	// ڑIvV̂NIvV
	for (int i = 0; i < __argc; i++) {
		int		deleteArg = false;
		if (_stricmp(__argv[i], OPT_LOCALE_EN) == 0) {
			processLocale = MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT);
			initLocale();
			deleteArg = true;
		} else if (_stricmp(__argv[i], OPT_DELETE_REG) == 0) {
			if (MessageBox(0, lgWindows::LoadString(rStringQuestionDeleteReg), lgWindows::TheName(), MB_OKCANCEL | MB_ICONEXCLAMATION | MB_DEFBUTTON2) == IDOK) {
				SHDeleteKey(HKEY_CURRENT_USER, lgWindows::LoadString(rStringRegistryRoot));
				SHDeleteKey(HKEY_CURRENT_USER, lgWindows::LoadString(rStringPreferenceRootUser));
				deleteArg = true;
			}
			return 0;
		}
		if (deleteArg) {
			for (int j = i; j < __argc-1; j++) __argv[j] = __argv[j+1];
			__argc--; __argv[__argc] = 0; i--;
		}
	}

	int tmp = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	tmp = tmp | _CRTDBG_CHECK_ALWAYS_DF | _CRTDBG_LEAK_CHECK_DF;
	_CrtSetDbgFlag(tmp);

	// SSL
	SSLeay_add_ssl_algorithms();
	SSL_library_init();

	/* Waffle 0.1.2: DllMain ŏ */
	DllMain(GetModuleHandle(0), DLL_PROCESS_ATTACH, 0);
    int result = lgWindows::Main(__argc, __argv);
	DllMain(GetModuleHandle(0), DLL_PROCESS_DETACH, 0);

	return result;
}
