/*
 * LIBGANA - library for GANA
 * Copyright (C) 1996-1997, TAGA Nayuta <nayuta@is.s.u-tokyo.ac.jp>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

///////////////////////////////////////////////////////////////////////////////
// lgcStatubar.h


#pragma	once

class lgcStatusbar : public lgWindow
{
  char *default_text;
  char *now_text;
  COLORREF fg, bg;
  BOOL is_tmp;
  
public:
  lgcStatusbar(HWND hwnd);
  ~lgcStatusbar();

  // eLXgݒ肷
  const char *SetDefaultText(const char *text);
  void SetText(const char *text = NULL);
  
  // Fݒ肷
  void SetColor(void);
  void SetColor(COLORREF _fg, COLORREF _bg, BOOL _is_tmp = TRUE);
  
  // I[i[h[
  int wmDrawItem(int id, DRAWITEMSTRUCT *dis);
};
